unit necklace;

interface

procedure init;
procedure create (from : longint; operation : char; on_left : boolean; param : longint);
function pearl (neck_id : longint; on_left : boolean) : longint;

implementation

type pperla = ^perla;
     perla = record
               v : longint;
	       next : pperla;
	     end;

     neck = record
              front, rear : pperla;
	    end;

procedure pushF (n : neck; v : longint; var nw : neck);
  var p : pperla;
begin
  new(p);
  p^.v := v;
  p^.next := n.front;;
  nw.front := p;
  nw.rear := n.rear;
end;

procedure pushR (n : neck; v : longint; var nw : neck);
  var p : pperla;
begin
  new(p);
  p^.v := v;
  p^.next := n.rear;;
  nw.rear := p;
  nw.front := n.front;
end;

function reverse (p:pperla):pperla;
var acc, np:pperla;
begin
  acc:= nil;

  while p <> nil do
    begin
     new (np);
     np^.v := p^.v;
     np^.next := acc;
     acc := np;
     p:= p^.next;
    end;
  reverse:=acc;
end;

procedure split(p:pperla; var zac, okon:pperla);
var a, na, z, l, da:pperla;
begin
  z := nil;
  l := nil;
  a := p;
  da := p;

  while (da <> nil) and (da^.next <> nil) do
    begin
      new(na);
      na^.v := a^.v;
      na^.next := nil;
      if l = nil then z := na else l^.next:= na;
      l := na;

      a:=a^.next;
      da:=da^.next^.next;
    end;

  zac := z;
  okon := reverse (a);
end;

procedure balance(var n:neck);
var a,b:pperla;
begin
if n.front = nil then
  begin
    split(n.rear,a,b);
    n.front := b;
    n.rear := a;
  end
else
  begin
    split(n.front,a,b);
    n.rear := b;
    n.front := a;
  end;
end;

procedure popF (var n : neck; var nw : neck);
begin
  if n.front = nil then balance (n);

  if n.front = nil then
    begin
      assert (n.rear^.next = nil);
      nw.front := nil;
      nw.rear := nil;
    end
  else
    begin
      nw.front := n.front^.next;
      nw.rear := n.rear;
    end;
end;

procedure popR (var n : neck; var nw : neck);
begin
  if n.rear = nil then balance (n);

  if n.rear = nil then
    begin
      assert (n.front^.next = nil);
      nw.front := nil;
      nw.rear := nil;
    end
  else
    begin
      nw.front := n.front;
      nw.rear := n.rear^.next;
    end;
end;

function topF (var n : neck) : longint;
begin
  if n.front = nil then balance (n);

  if n.front = nil then
    begin
      assert (n.rear^.next = nil);
      topF := n.rear^.v;
    end
  else
    topF := n.front^.v;
end;

function topR (var n : neck) : longint;
begin
  if n.rear = nil then balance (n);

  if n.rear = nil then
    begin
      assert (n.front^.next = nil);
      topR := n.front^.v;
    end
  else
    topR := n.rear^.v;
end;

procedure empty_neck (var nck: neck);
begin
 nck.front := nil;
 nck.rear := nil;
end;

var necks:array[0 .. 1000000] of neck;
    nnecks : longint;

procedure init;
begin
 nnecks := 1;
 empty_neck (necks[0]);
end;

procedure create (from : longint; operation : char; on_left : boolean; param : longint);
begin
  if operation = 'A' then
    begin
      if on_left then pushF (necks[from], param, necks[nnecks])
                 else pushR (necks[from], param, necks[nnecks]);
    end
  else
    begin
      if on_left then popF (necks[from], necks[nnecks])
                 else popR (necks[from], necks[nnecks]);
    end;
  inc (nnecks);
end;

function pearl (neck_id : longint; on_left : boolean) : longint;
begin
  if on_left then
    pearl := topF (necks[neck_id])
  else
    pearl := topR (necks[neck_id]);
end;

end.

