unit necklace;

interface

procedure init;
procedure create (from : longint; operation : char; on_left : boolean; param : longint);
function pearl (neck_id : longint; on_left : boolean) : longint;

implementation

type pperla = ^perla;
     perla = record
               v : longint;
	       prev, next : pperla;
	     end;

     neck = record
              zac, kon : pperla;
	    end;

var allocated : longint;

procedure duplicate_necklace (var n : neck);
  var p, np, last : pperla;
begin
  last := nil;

  p := n.zac;
  while p <> n.kon do
    begin
      new (np);
      inc (allocated);
      np^.v := p^.v;
      np^.prev := last;
      if last = nil then n.zac := np else last^.next := np;
      last := np;
      p := p^.next;
    end;
  new (np);
  inc (allocated);
  np^.v := p^.v;
  np^.prev := last;
  if last = nil then n.zac := np else last^.next := np;
  np^.next := nil;
  n.kon := np;

  { assert (allocated < 10000000); }
end;

procedure pushF (n : neck; v : longint; var nw : neck);
  var p : pperla;
begin
  new(p);
  p^.v := v;
  p^.prev := nil;

  if n.zac = nil then
    begin
      nw.zac := p;
      nw.kon := p;
      p^.next := nil;
    end
  else
    begin
      if n.zac^.prev <> nil then
        duplicate_necklace (n);
      nw.zac := p;
      nw.kon := n.kon;
      p^.next := n.zac;
      n.zac^.prev := p;
    end;
end;

procedure pushR (n : neck; v : longint; var nw : neck);
var p : pperla;
begin
  new(p);
  p^.v := v;
  p^.next := nil;

  if n.kon = nil then
    begin
      nw.zac := p;
      nw.kon := p;
      p^.prev := nil;
    end
  else
    begin
      if n.kon^.next <> nil then
        duplicate_necklace (n);
      nw.zac := n.zac;
      nw.kon := p;
      p^.prev := n.kon;
      n.kon^.next := p;
    end;
end;

procedure popF (n : neck; var nw : neck);
begin
  if n.zac = n.kon then
    begin
      nw.zac := nil;
      nw.kon := nil;
    end
  else
    begin
      nw.zac := n.zac^.next;
      nw.kon := n.kon;
    end;
end;

procedure popR (n : neck; var nw : neck);
begin
  if n.zac = n.kon then
    begin
      nw.zac := nil;
      nw.kon := nil;
    end
  else
    begin
      nw.zac := n.zac;
      nw.kon := n.kon^.prev;
    end;
end;

function topF (n : neck) : longint;
begin
  topF := n.zac^.v;
end;

function topR (n : neck) : longint;
begin
  topR := n.kon^.v;
end;

procedure empty_neck (var nck: neck);
begin
 nck.zac := nil;
 nck.kon := nil;
end;

var necks:array[0 .. 1000000] of neck;
    nnecks : longint;

procedure init;
begin
 nnecks := 1;
 empty_neck (necks[0]);
 allocated := 0;
end;

procedure create (from : longint; operation : char; on_left : boolean; param : longint);
begin
  if operation = 'A' then
    begin
      if on_left then pushF (necks[from], param, necks[nnecks])
                 else pushR (necks[from], param, necks[nnecks]);
    end
  else
    begin
      if on_left then popF (necks[from], necks[nnecks])
                 else popR (necks[from], necks[nnecks]);
    end;
  inc (nnecks);
end;

function pearl (neck_id : longint; on_left : boolean) : longint;
begin
  if on_left then
    pearl := topF (necks[neck_id])
  else
    pearl := topR (necks[neck_id]);
end;

procedure dump_necklace(nck : neck);
var p : pperla;
begin
  p := nck.zac;

  if p = nil then writeln ('[]')
     else
       begin
       while p <> nck.kon do
         write (p^.v, ' : ');
       write (p^.v, ' : []');
       end;
end;

procedure dump_necklaces;
var i : longint;
begin
  for i := 0 to nnecks - 1 do
    begin
    writeln ('Necklace ', i);
    dump_necklace (necks[i]);
    end;
end;

end.

