#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

//#define VDEBUG
//#define GENDATA

//create new necklace from old one
void create (int from, char operation, int on_left, int param);

//get left- or rightmost pearl color
int pearl(int neck_id, int on_left);

//initialize
void init();

#if 0
//debug routine -- returned string is global and reused by succesive necklace2str
const char* necklace2str(int neck_id);

//debug routine -- returned string is global and reused by succesive necklace2str
const char *necklace_status();
#endif

//commands (normal+VDEBUG mode):
// A neckl R/L color
// R neckl R/L
// Q neckl R/L result
// P neckl R 		to print necklace
// S 0 R		to print status

//commands (GENDATA mode)
// A neckl R/L 		append new value
// R neckl R/L
// Q neckl R/L 		determine result
// P and S are ignored

int main()
{
	char cmd[20],dir[20];
	int neckl, color, left, n=0, tmp;
	int maxcolor = 1;

	init();
	while(scanf("%s %d %s",cmd,&neckl,dir)>0)
	{
		left=-1;
		if(dir[0]=='L') left=1;
		if(dir[0]=='R') left=0;
		assert(left>=0);
		switch(cmd[0])
		{
			case 'A':
				n++;
#				ifndef GENDATA
				scanf("%d",&color);
#				else
				color=maxcolor++;
#				endif
				create(neckl,'A',left,color);
#				ifdef VDEBUG
				if(left)
					printf("%d <- %d + %s\n",n,color,necklace2str(neckl));
				else
					printf("%d <- %s + %d\n",n,necklace2str(neckl),color);
				printf("%d :  %s\n",n,necklace2str(n));
#				endif
#				ifdef GENDATA
				printf("A %d %s %d\n",neckl,dir,color);
#				endif
				break;
			case 'R':
				n++;
				create(neckl,'R',left,0);
#				ifdef VDEBUG
				if(left)
					printf("%d <- >>> %s\n",n,necklace2str(neckl));
				else
					printf("%d <- %s <<<\n",n,necklace2str(neckl));
				printf("%d :  %s\n",n,necklace2str(n));
#				endif
#				ifdef GENDATA
				printf("R %d %s\n",neckl,dir);
#				endif
				break;
			case 'Q':
#				ifndef GENDATA 
				scanf("%d",&color);
				tmp=pearl(neckl,left);
				if (color!=tmp)
				{
					printf("Wrong value (%d instead of %d) on necklace %d\n",tmp,color,neckl);
					return 0;
				}
#				else
				printf("Q %d %s %d\n",neckl,dir,pearl(neckl,left));
#				endif
				break;
#				ifdef VDEBUG
			case 'P':
#				ifndef GENDATA
				printf("%d :  %s\n",neckl,necklace2str(neckl));
#				endif
				break;
			case 'S':
#				ifndef GENDATA
				printf("STATUS: %s\n",necklace_status());
#				endif
				break;
#endif
			case 'X': break;
		}
	}
#ifdef GENDATA
	printf ("X 0 L\n");
#endif
	puts("It's a correct solution, my dear Watson.");
	return 0;
}

